<template>
  <div class="modal-card">
    <b-progress :value="progress" size="is-large" show-value :type="status">
      {{statusMessage}}
    </b-progress>
    <b-progress v-if="subProgress" size="is-large">
      {{subMessage}}
    </b-progress>
    <b-button
     v-if="progress === 100"
     type="is-success"
     tag="router-link"
     :to="{ name: 'Model', query: { id: modelId } }"
    >
    Go to model page
    </b-button>
  </div>
</template>

<script>
import { api } from '@/api.js'

export default {
  name: 'ModelUpload',
  props: {
    model: {
      type: Object,
      default: function () {
        return {}
      }
    }
  },
  data () {
    return {
      progress: 0,
      status: 'is-primary',
      statusMessage: '',
      subProgress: false,
      subMessage: '',
      modelId: null
    }
  },
  mounted () {
    this.saveModel()
  },
  methods: {
    preCheck () {
      if (this.model.name === undefined || this.model.name === null || this.model.name === '') {
        this.setError('The model name is empty')
        return false
      }

      return true
    },
    setProgress (step) {
      switch (step) {
        case 0:
          this.statusMessage = 'Sending description'
          this.progress = 25
          break
        case 1:
          this.statusMessage = 'Sending model file'
          this.progress = 50
          break
        case 2:
          this.statusMessage = 'Sending custom layers model'
          this.progress = 75
          break
        case 3:
          this.statusMessage = 'Upload completed !'
          this.progress = 100
          this.status = 'is-success'
          break
      }
    },
    setError (message) {
      this.statusMessage = message
      this.status = 'is-danger'
    },
    setSubMessage (message) {
      this.subMessage = message
    },
    async saveModel () {
      if (!this.preCheck()) return
      this.setProgress(0)
      var response = await api.postModel(this.model)
      if (response.error) {
        this.setError(response.message)
        return
      } else {
        this.modelId = response.message
      }

      if (this.model.file !== undefined) {
        console.log('Upload model ' + this.model.file)
        this.setProgress(1)
        this.subProgress = true
        if (!await api.uploadModelFile(this.modelId, this.model.file)) {
          this.subProgress = false
          this.setError('Model upload error')
          return
        }
        this.subProgress = false
      }

      if (this.model.customLayers !== undefined) {
        console.log('Upload layers ' + this.model.customLayers)
        this.setProgress(2)
        this.subProgress = true
        if (!await api.uploadLayers(this.model.id, this.model.customLayers)) {
          this.subProgress = false
          this.setError('Custom layer upload error')
          return
        }
        this.subProgress = false
      }

      this.setProgress(3)
    }
  }
}
</script>

<style>

</style>
